import { Event } from '@vscode/base-node/vs/base/common/event';
export interface WillShutdownEvent {
    veto(value: boolean | Thenable<boolean>): void;
    reason: ShutdownReason;
}
export interface ShutdownEvent {
    join(promise: Thenable<void>): void;
    reason: ShutdownReason;
}
export declare const enum ShutdownReason {
    CLOSE = 1,
    QUIT = 2,
    RELOAD = 3,
    LOAD = 4,
}
export declare const enum StartupKind {
    NewWindow = 1,
    ReloadedWindow = 3,
    ReopenedWindow = 4,
}
export declare const enum LifecyclePhase {
    Starting = 1,
    Restoring = 2,
    Running = 3,
    Eventually = 4,
}
export interface ILifecycleService {
    readonly startupKind: StartupKind;
    readonly phase: LifecyclePhase;
    readonly onWillShutdown: Event<WillShutdownEvent>;
    readonly onShutdown: Event<ShutdownEvent>;
    when(phase: LifecyclePhase): Thenable<void>;
}
export declare const NullLifecycleService: ILifecycleService;
